<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_FareGroupType ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_FareGroupType extends AbstractStructArrayBase
{
    /**
     * The FareGroupType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_FareGroupType[]
     */
    public $FareGroupType;
    /**
     * Constructor method for ArrayOfJP_FareGroupType
     * @uses ArrayOfJP_FareGroupType::setFareGroupType()
     * @param \StructType\JP_FareGroupType[] $fareGroupType
     */
    public function __construct(array $fareGroupType = array())
    {
        $this
            ->setFareGroupType($fareGroupType);
    }
    /**
     * Get FareGroupType value
     * @return \StructType\JP_FareGroupType[]|null
     */
    public function getFareGroupType()
    {
        return $this->FareGroupType;
    }
    /**
     * This method is responsible for validating the values passed to the setFareGroupType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFareGroupType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFareGroupTypeForArrayConstraintsFromSetFareGroupType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_FareGroupTypeFareGroupTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_FareGroupTypeFareGroupTypeItem instanceof \StructType\JP_FareGroupType) {
                $invalidValues[] = is_object($arrayOfJP_FareGroupTypeFareGroupTypeItem) ? get_class($arrayOfJP_FareGroupTypeFareGroupTypeItem) : sprintf('%s(%s)', gettype($arrayOfJP_FareGroupTypeFareGroupTypeItem), var_export($arrayOfJP_FareGroupTypeFareGroupTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FareGroupType property can only contain items of type \StructType\JP_FareGroupType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FareGroupType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FareGroupType[] $fareGroupType
     * @return \ArrayType\ArrayOfJP_FareGroupType
     */
    public function setFareGroupType(array $fareGroupType = array())
    {
        // validation for constraint: array
        if ('' !== ($fareGroupTypeArrayErrorMessage = self::validateFareGroupTypeForArrayConstraintsFromSetFareGroupType($fareGroupType))) {
            throw new \InvalidArgumentException($fareGroupTypeArrayErrorMessage, __LINE__);
        }
        $this->FareGroupType = $fareGroupType;
        return $this;
    }
    /**
     * Add item to FareGroupType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FareGroupType $item
     * @return \ArrayType\ArrayOfJP_FareGroupType
     */
    public function addToFareGroupType(\StructType\JP_FareGroupType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_FareGroupType) {
            throw new \InvalidArgumentException(sprintf('The FareGroupType property can only contain items of type \StructType\JP_FareGroupType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FareGroupType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_FareGroupType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_FareGroupType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_FareGroupType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_FareGroupType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_FareGroupType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareGroupType
     */
    public function getAttributeName()
    {
        return 'FareGroupType';
    }
}
